CON
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000

  StepsPerKeypress = 1000
  
CON
  c_DebugLED = 27

CON
  DelayTime = 10

CON
  Rows    = 13
  Columms = 40
  DisplayBufferSize = Rows * Columms

CON
  Key0 = 48  
  Key1 = 49  
  Key2 = 50  
  Key3 = 51  
  Key4 = 52  
  Key5 = 53  
  Key6 = 54  
  Key7 = 55  
  Key8 = 56  
  Key9 = 57
  RewriteMenu = -1


CON 
  'constants for communication between ASM-stepper-driver and SPIN
  'to keep it VERY clear who (the cog running SPIN or another cog running ASM)
  'is doing what at any time there are two different variables
  'S2A means write->read-direction SPIN-->to-->Assembler    SPIN writes ASM  reads
  'A2S means write->read-direction Assembler-->to-->SPIN    ASM  writes SPIN reads
  'also the constants have IDs at the beginning
  c_S2A_Start_StepOut = 1                                   
  c_S2A_Stop          = 2
  c_S2A_Reference     = 3
  c_S2A_do_nothing    = 9
  
  c_A2S_wait_for_Cmd  = 10
  c_A2S_StepOutBusy   = 22
  c_A2S_ReferenceBusy = 33
  c_A2S_finished      = 99
  c_A2S_Error         = 77
  
CON
  ptr2_S2A_Status  = 0
  ptr2_A2S_Status  = ptr2_S2A_Status + 4 'adresses relative to par from cognew(@entry, @xStart)
  
  ptr2xStart       = ptr2_A2S_Status + 4  
  ptr2yStart       = ptr2xStart + 4
  ptr2xEnde        = ptr2yStart + 4
  ptr2yEnde        = ptr2xEnde  + 4

  ptr2TestVar1     = ptr2yEnde    + 4 
  ptr2TestVar2     = ptr2TestVar1 + 4

  ptr2X = ptr2TestVar2 + 4
  ptr2Y = ptr2X        + 4
   
VAR
  'constants for communication between ASM-stepper-driver and SPIN
  'to keep it VERY clear who (SPIN and ASM) is doing what at any time there are two different variables
  'S2A means write->read-direction SPIN-->to-->Assembler    SPIN writes ASM  reads
  'A2S means write->read-direction Assembler-->to-->SPIN    ASM  writes SPIN reads
  long S2A_Status 'variable for writing in SPIN reading in ASM   SPIN-->to-->Assembler 
  long A2S_Status 'variable for reading in SPIN writing in ASM   Assembler-->to-->SPIN
  
  long xStart         'startposition of X-coordinate of the vector for Steppermotorpulses  
  long yStart         'startposition of Y-coordinate of the vector for Steppermotorpulses
  long xEnde          'endposition   of X-coordinate of the vector for Steppermotorpulses
  long yEnde          'endposition   of Y-coordinate of the vector for Steppermotorpulses
          
  long TestVar1  
  long TestVar2 

  long X
  long Y
  long dummy

  
CON 'constants for IO-Pins driving the steppermotors
  X_Pulse = 0
  X_Dir   = 1

  Y_Pulse = 2
  Y_Dir   = 3

  Enable_Pin_no = 6

  OutPut = 1
  InPut  = 0

  high = 1
  low  = 0

CON
  X_Ref_Ini = 8
  Y_Ref_Ini = 9

  X_Ref_INI_On  = 1
  X_Ref_INI_Off = not X_Ref_INI_On 
  
  Y_Ref_INI_On  = 1
  Y_Ref_INI_Off = not Y_Ref_INI_On 
  
  Dir_towards_X_Ref_INI   = 0
  Dir_away_from_X_Ref_INI = not Dir_towards_X_Ref_INI 
  Dir_X_positive        = 1
  Dir_X_negative        = not Dir_X_positive 
  
  Dir_towards_Y_Ref_INI   = 0
  Dir_away_from_Y_Ref_INI = not Dir_towards_Y_Ref_INI 
  Dir_Y_positive        = 1
  Dir_Y_negative        = not Dir_Y_positive 

  XMin = 0
  XMax = 4
  
  YMin = 0
  YMax = 2

  StartStopSpeed_Time  = 50
  MaxSteps_Ref_Ini_Off = 5

  _50microSecs = 80_000_000 / 1_000_000 * 50
  'StartStopSpeed_halfTime = 80_000_000 / 1_000_000 * 500 
  StartStopSpeed_halfTime = 80_000_000 / 1_000 * 2000 

CON
  ErrCode_X_Ref_not_switch_on  = 100
  ErrCode_X_Ref_not_switch_off = 101      

  ErrCode_Y_Ref_not_switch_on  = 200
  ErrCode_Y_Ref_not_switch_off = 201

  Heartbeat_Pin_no = 27


VAR
  long cog
  long j
  long KeyboardCode

  long X_actual_Pos
  long Y_actual_Pos
  long Z_actual_Pos

  long X_Set_Pos
  long Y_Set_Pos
  long Z_Set_Pos

  
OBJ
  PC_Text    : "PC_Text_advanced"
  PC_Keyb    : "PC_Keyboard"
  heart      : "heartbeat"     'object that makes an LED blink for showing propeller-chip is alive and working
  

PUB MainLoop2 | i, KeyCode

  Heart.start(Heartbeat_Pin_no,250) 'start cog to blink IO_Pin_no at 1/0,500 seconds = 2 Hz
  'start ASM-Driver terminal in a cog
  PC_Text.start(31) 'rxpin, txpin rx/tx from the sight of the propellerchip. Propeller-rx <-----receive from PC, Propeller-tx -----> send to PC
  PC_Keyb.start(31,30)

  dira[Enable_Pin_no] := 1

  outa[Enable_Pin_no] := 1

  PC_Keyb.clearkeys
  i := 0
  repeat until (KeyCode == 115)
    if PC_Keyb.gotkey
      KeyCode := PC_Keyb.GetKey
    PC_Text.Writeln(string("wait for key S to start"))
    wait_MS(500)
    i := i + 1
    if i == 12
      i := 0
      PC_Text.ClearScreen

  PC_Text.ClearScreen

  'PC_Text.Writeln(string("direct vor cognew"))
  cog := cognew(@entry, @S2A_Status) + 1
  'PC_Text.Writeln(string("direct nach cognew"))
  'ShowMessageWaitForKeypressed(string("stepOut-cog gestartet"))
    
  KeyCode := 0
  PC_Keyb.clearkeys
  PC_Text.Writeln(string("waiting for commands"))
  DirA[X_Dir]   := OutPut
  DirA[X_Pulse] := OutPut

  DirA[Y_Dir]   := OutPut
  DirA[Y_Pulse] := OutPut
  
  KeyCode := RewriteMenu
  
  repeat
    'Menu for PUB MainLoop | i, KeyCode 
    if KeyCode == RewriteMenu
      PC_Text.ClearScreen    '1234567890123456789012345678901234567890
      PC_Text.Writeln(string("1.Toggle Steppermotorbits"))
      PC_Text.Writeln(string("2.Test Reference"))
      PC_Text.Writeln(string("3.Test Step out"))
      PC_Text.Writeln(string("4.Axis Manual Mode"))
      PC_Text.Writeln(string("9.Next Menu  0.End"))
      KeyCode := 0

    if PC_Keyb.gotkey
      KeyCode := PC_Keyb.GetKey

    case KeyCode
      Key0:
        PC_Text.Writeln(string("Key0"))
        KeyCode := RewriteMenu    
        
      Key1:
        PC_Text.Writeln(string("Key1"))
        ToggleStepperMotorBits
        KeyCode := RewriteMenu    
        
      Key2:
        PC_Text.Writeln(string("Key2"))
        TestReference
        KeyCode := RewriteMenu    
        
      Key3:
        PC_Text.Writeln(string("Key3"))
        Test_StepOut
        KeyCode := RewriteMenu    
        
      Key4:
        PC_Text.Writeln(string("Key4"))
        Axis_Manual_Mode
        KeyCode := RewriteMenu    
        
      Key5:
        PC_Text.Writeln(string("Key5"))
        KeyCode := RewriteMenu    
        
      Key6:
        PC_Text.Writeln(string("Key6"))
        KeyCode := RewriteMenu    
        
      Key7:
        PC_Text.Writeln(string("Key7"))
        KeyCode := RewriteMenu    
        
      Key8:
        PC_Text.Writeln(string("Key9"))
        KeyCode := RewriteMenu    
        
      Key9:
        PC_Text.Writeln(string("Key9"))
        KeyCode := RewriteMenu    
       

PUB Test_StepOut | KeyCode 

  KeyCode := RewriteMenu    
  repeat until KeyCode == Key0
    'Menu for PUB Test_StepOut | KeyCode 
    if KeyCode == RewriteMenu
      PC_Text.ClearScreen    '1234567890123456789012345678901234567890
      PC_Text.Writeln(string("1.) XS= 1 YS=1  XE=11  YE=6"))
      PC_Text.Writeln(string("2.) XS=11 YS=6  XE= 1  YE=1"))
      PC_Text.Writeln(string("3.) XS= 0 YS=0  XE=10  YE=2"))
      PC_Text.Writeln(string("4.) 100 x+      5.) 100 X-"))
      PC_Text.Writeln(string("6.) 100 Y+      7.) 100 Y-"))
      PC_Text.Writeln(string("8.) XmaxYMax    9.) XminYMin"))
      
      PC_Text.Writeln(string("0.End"))
      KeyCode := 0

    if PC_Keyb.gotkey
      KeyCode := PC_Keyb.GetKey

    case KeyCode
      Key0:
        PC_Text.Writeln(string("Key0"))
        
      Key1:
        PC_Text.Writeln(string("Key1"))
        StepsOutToPosXY(1,1,11,6)
        KeyCode := RewriteMenu    
        
      Key2:
        PC_Text.Writeln(string("Key2"))
        StepsOutToPosXY(11,6,1,1)
        KeyCode := RewriteMenu    
        
      Key3:
        PC_Text.Writeln(string("Key3"))
        StepsOutToPosXY(0,0,29,2)
        KeyCode := RewriteMenu    
        
      Key4:
        PC_Text.Writeln(string("Key4"))
        StepsOutToPosXY(0,0,StepsPerKeypress,0)
        KeyCode := RewriteMenu    
        
      Key5:
        PC_Text.Writeln(string("Key5"))
        StepsOutToPosXY(StepsPerKeypress,0,0,0)
        KeyCode := RewriteMenu    
        
      Key6:
        PC_Text.Writeln(string("Key6"))
        StepsOutToPosXY(0,0,0,StepsPerKeypress)
        KeyCode := RewriteMenu    
        
      Key7:
        PC_Text.Writeln(string("Key7"))
        StepsOutToPosXY(0,StepsPerKeypress,0,0)
        KeyCode := RewriteMenu    
        
      Key8:
        PC_Text.Writeln(string("Key8"))
        StepsOutToPosXY(0,0,60000,40000)
        KeyCode := RewriteMenu    
        
      Key9:
        PC_Text.Writeln(string("Key9"))
        StepsOutToPosXY(60000,40000,0,0)
        KeyCode := RewriteMenu    

        
PUB ToggleStepperMotorBits | KeyCode

  KeyCode := RewriteMenu
  repeat until KeyCode == Key0
    'Menu for PUB ToggleStepperMotorBits | KeyCode
    if KeyCode == RewriteMenu
      PC_Text.ClearScreen    '1234567890123456789012345678901234567890
      PC_Text.Writeln(string("1.X_Dir  2.X_Pulse   3.Y_Dir  4.Y_Pulse"))
      PC_Text.Writeln(string("9.Next Menu  0.back"))
      KeyCode := 0    

    if PC_Keyb.gotkey
      KeyCode := PC_Keyb.GetKey

    case KeyCode
      Key0:
        PC_Text.Writeln(string("Key0"))
        
      Key1:
        PC_Text.Writeln(string("Key1"))
        !OutA[X_Dir]
        KeyCode := RewriteMenu    
        
      Key2:
        PC_Text.Writeln(string("Key2"))
        !OutA[X_Pulse]
        KeyCode := RewriteMenu    
        
      Key3:
        PC_Text.Writeln(string("Key3"))
        !OutA[Y_Dir]
        KeyCode := RewriteMenu    
        
      Key4:
        PC_Text.Writeln(string("Key4"))
        !OutA[Y_Pulse]
        KeyCode := RewriteMenu    
        
      Key5:
        PC_Text.Writeln(string("Key5"))
        KeyCode := RewriteMenu    
        
      Key6:
        PC_Text.Writeln(string("Key6"))
        KeyCode := RewriteMenu    
        
      Key7:
        PC_Text.Writeln(string("Key7"))
        KeyCode := RewriteMenu    
        
      Key8:
        PC_Text.Writeln(string("Key9"))
        KeyCode := RewriteMenu    
        
      Key9:
        PC_Text.Writeln(string("Key9"))
        KeyCode := RewriteMenu    

  OutA[X_Dir]   := 0
  OutA[X_Pulse] := 0
  OutA[Y_Dir]   := 0
  OutA[Y_Pulse] := 0


PUB TestReference | KeyCode, ErrCode, i
  ErrCode := 0
  KeyCode := RewriteMenu 

  repeat until KeyCode == Key0
    if KeyCode == RewriteMenu
      PC_Text.ClearScreen    '1234567890123456789012345678901234567890
      PC_Text.Writeln(string("1.X_Ref towards  2.X_Ref back until off"))
      PC_Text.Writeln(string("3.Y_Ref towards  4.Y_Ref back until off"))
      PC_Text.Writeln(string("5.Show DirBitValues"))
         
      PC_Text.Writeln(string("9.Next Menu  0.back"))
      KeyCode := 0    

    'ShowIO
       
    if PC_Keyb.gotkey
      KeyCode := PC_Keyb.GetKey

    case KeyCode
      Key0:
        PC_Text.Writeln(string("Key0"))
        
      Key1:
        PC_Text.Writeln(string("Key1"))
        ErrCode := Find_X_Ref_INI
        KeyCode := RewriteMenu    
        
      Key2:
        PC_Text.Writeln(string("Key2"))
        ErrCode := Back_from_X_Ref_INI_until_off
        KeyCode := RewriteMenu    
        
      Key3:
        PC_Text.Writeln(string("Key3"))
        ErrCode := Find_Y_Ref_INI
        KeyCode := RewriteMenu    
        
      Key4:
        PC_Text.Writeln(string("Key4"))
        ErrCode := Back_from_Y_Ref_INI_until_off
        KeyCode := RewriteMenu    
        
      Key5:
        PC_Text.Writeln(string("Key5"))
        ShowDirBitValues
        KeyCode := RewriteMenu    
        
      Key6:
        PC_Text.Writeln(string("Key6"))
        KeyCode := RewriteMenu    
        
      Key7:
        PC_Text.Writeln(string("Key7"))
        KeyCode := RewriteMenu    
        
      Key8:
        PC_Text.Writeln(string("Key9"))
        KeyCode := RewriteMenu    
        
      Key9:
        PC_Text.Writeln(string("Key9"))
        KeyCode := RewriteMenu    

    if ErrCode <> 0
      ErrCode := ShowErrMessage(ErrCode)
       
  KeyCode := RewriteMenu 


PUB ShowDirBitValues

  PC_Text.Write(string("X_Ref_INI_On="))
  PC_Text.Dec(X_Ref_INI_On)
  PC_Text.Writeln(string(" "))

  PC_Text.Write(string("X_Ref_INI_Off="))
  PC_Text.Dec(X_Ref_INI_Off)
  PC_Text.Writeln(string(" "))

  ShowMessageWaitForKeypressed(string(" "))    


PUB ShowIO | i

  PC_Text.SetCursorToXY(0,5)

  PC_Text.Writeln(string("00 01 02 03 04 05 06 07"))
  
  repeat i from 0 to 7
    if DirA[i] == 1
      PC_Text.Write(string("O"))
      PC_Text.Dec(OutA[i])
    else   
      PC_Text.Write(string("I"))
      PC_Text.Dec(InA[i])

    PC_Text.Write(string(" "))

  PC_Text.out(13)

  PC_Text.Writeln(string("08 09 10 11 12 13 14 15"))
  repeat i from 8 to 15
    if DirA[i] == 1
      PC_Text.Write(string("O"))
      PC_Text.Dec(OutA[i])
    else   
      PC_Text.Write(string("I"))
      PC_Text.Dec(InA[i])

    PC_Text.Write(string(" "))

  PC_Text.out(13)

  PC_Text.Writeln(string("16 17 18 19 20 21 22 23"))
  repeat i from 16 to 23
    if DirA[i] == 1
      PC_Text.Write(string("O"))
      PC_Text.Dec(OutA[i])
    else   
      PC_Text.Write(string("I"))
      PC_Text.Dec(InA[i])

    PC_Text.Write(string(" "))

  PC_Text.out(13)

  PC_Text.Writeln(string("24 25 26 27 28 29 30 31"))
  repeat i from 24 to 31
    if DirA[i] == 1
      PC_Text.Write(string("O"))
      PC_Text.Dec(OutA[i])
    else   
      PC_Text.Write(string("I"))
      PC_Text.Dec(InA[i])

    PC_Text.Write(string(" "))


PUB Find_X_Ref_INI | steps

  steps := 0
  OutA[X_Dir] := Dir_towards_X_Ref_INI

  repeat until (InA[X_Ref_Ini] == X_Ref_INI_On) or (steps > XMax)
    steps := steps + 1
    OutA[X_Pulse] := high
    wait_MicroSec(StartStopSpeed_Time)
    OutA[X_Pulse] := low
    wait_MicroSec(StartStopSpeed_Time)
    {
    PC_Text.dec(steps)
    wait_MS(40)
    PC_Text.out(13)
    wait_MS(40)
    }
    PC_Text.Dec(steps)  
    ShowMessageWaitForKeypressed(string(" steps Find_X_Ref_INI"))    

    {
    if InA[X_Ref_Ini] == X_Ref_INI_On
      PC_Text.Writeln(string("InA[X_Ref_Ini] == X_Ref_INI_On"))
      wait_MS(40)
    else   
      PC_Text.Writeln(string("InA[X_Ref_Ini] <> X_Ref_INI_On"))
      wait_MS(40)
     }
  if (steps > XMax) 
    result := ErrCode_X_Ref_not_switch_on  

  PC_Text.Dec(steps)  
  ShowMessageWaitForKeypressed(string(" steps Find_X_Ref_INI"))    

                
PUB Find_Y_Ref_INI | steps

  steps := 0
  OutA[Y_Dir] := Dir_towards_Y_Ref_INI

  repeat until (InA[Y_Ref_Ini] == Y_Ref_INI_On) or (steps > YMax)
    steps := steps + 1
    OutA[Y_Pulse] := high
    wait_MicroSec(StartStopSpeed_Time)

    OutA[Y_Pulse] := low
    wait_MicroSec(StartStopSpeed_Time)

    PC_Text.Dec(steps)  
    ShowMessageWaitForKeypressed(string(" steps Find_Y_Ref_INI"))

  if (steps > YMax) 
    result := ErrCode_Y_Ref_not_switch_on  

  PC_Text.Dec(steps)  
  ShowMessageWaitForKeypressed(string(" steps Find_Y_Ref_INI"))    


PUB Back_from_X_Ref_INI_until_off | steps

  steps := 0
  OutA[X_Dir] := Dir_away_from_X_Ref_INI

  repeat until (InA[X_Ref_Ini] == X_Ref_INI_Off) or (steps > MaxSteps_Ref_Ini_Off)
    steps := steps + 1
    OutA[X_Pulse] := high
    wait_MicroSec(StartStopSpeed_Time)
    OutA[X_Pulse] := low
    wait_MicroSec(StartStopSpeed_Time)
    PC_Text.Dec(steps)  
    ShowMessageWaitForKeypressed(string(" steps Back_from_X_Ref_INI_until_off"))    
    
  if (steps > MaxSteps_Ref_Ini_Off) 
    result := ErrCode_X_Ref_not_switch_off  

  PC_Text.Dec(steps)  
  ShowMessageWaitForKeypressed(string(" steps Back_from_X_Ref_INI_until_off"))    

                      
PUB Back_from_Y_Ref_INI_until_off | steps

  steps := 0
  OutA[Y_Dir] := Dir_away_from_Y_Ref_INI

  repeat until (InA[Y_Ref_Ini] == Y_Ref_INI_Off) or (steps > MaxSteps_Ref_Ini_Off)
    steps := steps + 1
    OutA[Y_Pulse] := high
    wait_MicroSec(StartStopSpeed_Time)
    OutA[Y_Pulse] := low
    wait_MicroSec(StartStopSpeed_Time)
    PC_Text.Dec(steps)  
    ShowMessageWaitForKeypressed(string(" steps Back_from_Y_Ref_INI_until_off"))    

  if (InA[Y_Ref_Ini] == Y_Ref_INI_Off)
    ShowMessageWaitForKeypressed(string(" (InA[Y_Ref_Ini] == Y_Ref_INI_Off)"))
     
  if (steps > MaxSteps_Ref_Ini_Off) 
    result := ErrCode_Y_Ref_not_switch_off  

  PC_Text.Dec(steps)  
  ShowMessageWaitForKeypressed(string(" steps Back_from_Y_Ref_INI_until_off"))    

                      
PUB wait_MicroSec(p_WaitTime_MicroSec) 

  if p_WaitTime_MicroSec < 385 
    p_WaitTime_MicroSec := 385
     
  waitcnt( ((clkfreq / 1_000_000) * p_WaitTime_MicroSec) + cnt)

      
PUB wait_MS(p_WaitTime_ms) 

  waitcnt( ((clkfreq / 1000) * p_WaitTime_ms) + cnt)


PUB ShowErrMessage(ErrCode)
  PC_Text.ClearScreen    '1234567890123456789012345678901234567890
  PC_Text.Write(string("an Error occured ErrCode="))
  PC_Text.Dec(ErrCode)
  PC_Text.out(13)
  
  PC_Text.Write(string("press any Key to ackknowledge"))
  PC_Keyb.GetKey


PUB ShowMessageWaitForKeypressed(stringptnr)

  'PC_Text.ClearScreen   
  PC_Text.Writeln(stringptnr)
  wait_MS(40)
  PC_Text.Writeln(string("press any Key to ackknowledge"))
  wait_MS(40)
  PC_Keyb.GetKey


PUB StepsOutToPosXY(p_XStart,p_YStart,p_XEnde,p_YEnde)
  InitVector(p_XStart,p_YStart,p_XEnde,p_YEnde)
  PC_Text.Writeln(string("S2A_Status := c_S2A_Start_StepOut"))

  S2A_Status := c_S2A_Start_StepOut
  repeat until A2S_Status == c_A2S_StepOutBusy
  S2A_Status := c_S2A_do_nothing    
                         '1234567890123456789012345678901234567890
  PC_Text.Writeln(string("repeat until Status==c_A2S_wait_for_Cmd"))
  repeat until A2S_Status == c_A2S_wait_for_Cmd


PUB InitVector(p_XStart,p_YStart,p_XEnde,p_YEnde)

  xStart := p_XStart
  yStart := p_YStart

  xEnde := p_XEnde
  yEnde := p_YEnde

  PC_Text.Write(string("xStart="))
  PC_Text.Dec(xStart)
  
  PC_Text.Write(string(" xEnd="))
  PC_Text.Dec(xEnde)
  PC_Text.Out(13)

  PC_Text.Write(string("yStart="))
  PC_Text.Dec(yStart)
  
  PC_Text.Write(string(" yEnd="))
  PC_Text.Dec(yEnde)
  PC_Text.Out(13)

  'ShowMessageWaitForKeypressed(string(" "))


PUB Drive_Axis_to_zero


PUB Set_Actual_Pos_to_Zero
  X_actual_Pos := 0
  Y_actual_Pos := 0
  Z_actual_Pos := 0


PUB Axis_Manual_Mode | KeyCode

  KeyCode := RewriteMenu
  repeat until KeyCode == Key0
    'Menu for PUB Axis_Manual_Mode
    if KeyCode == RewriteMenu
      PC_Text.ClearScreen    '1234567890123456789012345678901234567890
      PC_Text.Writeln(string("1.X+ 1mm 2.X- 1mm 3.X+ 100mm  4.X- 100mm"))
      PC_Text.Writeln(string("5.Y+ 1mm 6.Y- 1mm 7.Y+ 100mm  8.Y- 100mm"))
      PC_Text.Writeln(string("9.Next Menu  0.back"))
      KeyCode := 0    

    if PC_Keyb.gotkey
      KeyCode := PC_Keyb.GetKey

    case KeyCode
      Key0:
        PC_Text.Writeln(string("Key0"))
        
      Key1:
        PC_Text.Writeln(string("Key1"))
        KeyCode := RewriteMenu    
        
      Key2:
        PC_Text.Writeln(string("Key2"))
        KeyCode := RewriteMenu    
        
      Key3:
        PC_Text.Writeln(string("Key3"))
        KeyCode := RewriteMenu    
        
      Key4:
        PC_Text.Writeln(string("Key4"))
        KeyCode := RewriteMenu    
        
      Key5:
        PC_Text.Writeln(string("Key5"))
        KeyCode := RewriteMenu    
        
      Key6:
        PC_Text.Writeln(string("Key6"))
        KeyCode := RewriteMenu    
        
      Key7:
        PC_Text.Writeln(string("Key7"))
        KeyCode := RewriteMenu    
        
      Key8:
        PC_Text.Writeln(string("Key9"))
        KeyCode := RewriteMenu    
        
      Key9:
        PC_Text.Writeln(string("Key9"))
        KeyCode := RewriteMenu    


DAT           
              ORG 0 'Begin at Cog RAM addr 0
entry         
              call      #SetOutPutBits
              call      #Transf_SPINvar_2_ASMvar

ASM_MainLoop    nop
                mov     _A2S_Status,#c_A2S_wait_for_Cmd
                call    #Transf_SPINvar_2_ASMvar
                call    #Transf_ASMvar_2_SPINvar
                              
                mov     p,par
                add     p,#ptr2_S2A_Status
                rdlong  _S2A_Status,p
                sub     _S2A_Status,#c_S2A_Start_StepOut wz, nr

          if_z  jmp     #stepper_pulses_Out

                sub     _S2A_Status,#c_S2A_Stop wz, nr
          if_z  jmp     #stop
          
              jmp       #ASM_MainLoop

              
'START of Stepper_pulses_out
stepper_pulses_Out
              call      #SetOutPutBits
              mov       _A2S_Status,#c_A2S_StepOutBusy
              call      #Transf_SPINvar_2_ASMvar
              call      #Transf_ASMvar_2_SPINvar

calculate_dx
              mov       _dx,_xEnde              'calculate
              subs      _dx,_xStart wz          'xEnde - xStart and store result in _dx
      if_z    call      #_dx_is_zero    

              mins      _dx,#0 wc, nr
if_nc_and_nz  call      #_dx_is_positive
if_c_and_nz   call      #_dx_is_negative

calculate_dy
              mov       _dy,_yEnde              'calculate
              subs      _dy,_yStart wz          'yEnde - yStart and store result in _dy
      if_z    call      #_dy_is_zero    

              mins      _dy,#0 wc, nr
if_nc_and_nz  call      #_dy_is_positive  
if_c_and_nz   call      #_dy_is_negative

'wait a short period of time to give the steppermotor-driver
'time to recognize the logical level of the direction-signal
wait_DirBits_to_be_recognized                            
              mov       _CntTargetValue, cnt                                    'store momentary value of systemcounter cnt
              add       _CntTargetValue, #_c_delay50MicroSecs                   'microSecs          'Set delay here
              waitcnt   _CntTargetValue, #0 nr                                  'Wait pause cog until systemcounter cnt matches the value in _CntTargetValue 
                     
find_bigger_distance
              maxs      _dx,_dy nr, wc          'if _dx is smaller than _dy then the c-Flag is set to 1 
        if_c  mov       _distance,_dy           'if C-flag is set 
        if_nc mov       _distance,_dx

Init_Stepper_Pulse_Loop
              mov       _x,_xStart
              mov       _y,_yStart

              mov       _xerr,_dx
              mov       _yerr,_dy

              mov       _XY_SetPulseBitMask,   #0       'Init long for SETTING  XY-pulse-bits with 0

              mov       _XY_ClearPulseBitMask, #0       'Init long for CLEARING XY-pulse-bits 
              or        _XY_ClearPulseBitMask, _c_X_Pulse
              or        _XY_ClearPulseBitMask, _c_Y_Pulse

              mov       _StepCounter,_distance  'load amount of steps into long _StepCounter 
              
              mov       _CntTargetValue, cnt            'store momentary value of systemcounter cnt in _CntTargetValue 
              add       _CntTargetValue,_delay

Stepper_Pulses_Loop
                  call      #ClearXY_Pulse_Bits

                  waitcnt   _CntTargetValue,_delay 

                  adds      _xerr,_dx
                  maxs      _distance,_xerr nr, wc          'if _distance is smaller than _xerr then the c-Flag is set to 1 
            if_c  call      #set_X_Pulse_Bit                'if C-flag is set
            if_nc call      #clear_X_Pulse_Bit               
             
                  adds      _yerr,_dy
                  maxs      _distance,_yerr nr, wc          'if _distance is smaller than _xerr then the c-Flag is set to 1 
            if_c  call      #set_Y_Pulse_Bit                'if C-flag is set 
            if_nc call      #clear_Y_Pulse_Bit               

                  call      #SetXY_Pulse_Bits

                  waitcnt   _CntTargetValue,_delay 
                  djnz      _StepCounter, #Stepper_Pulses_Loop

                  call      #ClearXY_Pulse_Bits

                  mov       _A2S_Status,#c_A2S_finished
                  mov       p,par               
                  add       p,#ptr2_A2S_Status
                  wrlong    _A2S_Status,p

                  jmp       #ASM_MainLoop
'END of Stepper_pulses_out
               
stop
              call      #ClearXY_Pulse_Bits

              jmp       #Transfer_Result_To_Hub_RAM

              
'SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
'# START Subroutines 
'#########################################################
              'First of all: read variables that communicate between SPIN-cog and ASM-cog
              'Transfer values of SPIN-Variables (stored in HUB-RAM) to ASM-Variables (stored in Cog-RAM)
              'The pattern "mov p,par" "add p,#constantName" is used for everey variable
              'because then there is only ONE place to calculate the offsetvalues.
              'This will need some additional longs in COG-RAM but as long as the ASM-Routine does not come
              'close to the COG-RAM-Limit that doesn't matters
              'This place is in the CON-Block. And even there its possible to halfautomate calculation by
              'using the constantname of one line above + 4
              'just keep the sequence of the "ptr2"-constants in the same sequence as the SPIN-variables
              'and everything is done
Transf_SPINvar_2_ASMvar                  
              mov       p,par
              add       p,#ptr2_S2A_Status
              rdlong    _S2A_Status,p

              mov       p,par
              add       p,#ptr2xStart
              rdlong    _xStart,p

              mov       p,par
              add       p,#ptr2yStart
              rdlong    _yStart,p

              mov       p,par
              add       p,#ptr2xEnde
              rdlong    _xEnde,p

              mov       p,par
              add       p,#ptr2yEnde
              rdlong    _yEnde,p


              mov       p,par
              add       p,#ptr2TestVar1
              rdlong    _TestVar1,p

              mov       p,par
              add       p,#ptr2TestVar2
              rdlong    _TestVar2,p

              mov       p,par
              add       p,#ptr2X
              rdlong    _X,p

              mov       p,par
              add       p,#ptr2Y
              rdlong    _Y,p
Transf_SPINvar_2_ASMvar_ret ret
'---------------------------------------------------------

'#########################################################
Transf_ASMvar_2_SPINvar                  
              mov       p,par               
              add       p,#ptr2_A2S_Status
              wrlong    _A2S_Status,p

              mov       p,par
              add       p,#ptr2TestVar1
              wrlong    _TestVar1,p

              mov       p,par
              add       p,#ptr2TestVar2
              wrlong    _TestVar2,p

              mov       p,par
              add       p,#ptr2X
              wrlong    _X,p

              mov       p,par
              add       p,#ptr2Y
              wrlong    _Y,p
Transf_ASMvar_2_SPINvar_ret ret
'---------------------------------------------------------


'#########################################################
SetOutPutBits
              mov       _XYBitMask,_c_X_Dir
              or        _XYBitMask,_c_X_Pulse
              or        _XYBitMask,_c_Y_Dir
              or        _XYBitMask,_c_Y_Pulse

              mov       _dummylong,#1 wz
              muxnz     DirA,_XYBitMask         'set IO-Pins as Output
              muxz      OutA,_XYBitMask         'set IO-Pins to low
SetOutPutBits_ret ret
'---------------------------------------------------------


'#########################################################
_dx_is_zero
              mov       _incx,#0
_dx_is_zero_ret ret
'---------------------------------------------------------


'#########################################################
_dx_is_negative
              mov       _incx,#1
              neg       _incx,_incx 
              neg       _dx,_dx

              mov       _dummylong,#Dir_X_negative wz
              muxnz     OutA,_c_X_Dir 
_dx_is_negative_ret ret              
'---------------------------------------------------------


'#########################################################
_dx_is_positive
              mov       _incx,#1

              mov       _dummylong,#Dir_X_positive wz
              muxnz     OutA,_c_X_Dir 
_dx_is_positive_ret ret
'---------------------------------------------------------


'#########################################################
_dy_is_zero
              mov       _incy,#0
_dy_is_zero_ret ret
'---------------------------------------------------------


'#########################################################
_dy_is_negative
              mov       _incy,#1
              neg       _incy,_incy
              neg       _dy,_dy 

              mov       _dummylong,#Dir_Y_negative  wz
              muxnz     OutA,_c_Y_Dir 
_dy_is_negative_ret ret
'---------------------------------------------------------


'#########################################################
_dy_is_positive
              mov       _incy,#1

              mov       _dummylong,#Dir_Y_positive  wz
              muxnz     OutA,_c_Y_Dir 
_dy_is_positive_ret ret
'---------------------------------------------------------


'#########################################################
set_X_Pulse_Bit
              subs      _xerr,_distance
              adds      _x,_incx
              mov       _dummylong,#1 wz
              muxnz     _XY_SetPulseBitMask,_c_X_Pulse
set_X_Pulse_Bit_ret ret
'---------------------------------------------------------


'#########################################################
clear_X_Pulse_Bit               
              mov       _dummylong,#0 wz
              muxnz     _XY_SetPulseBitMask,_c_X_Pulse
clear_X_Pulse_Bit_ret ret
'---------------------------------------------------------


'#########################################################
set_Y_Pulse_Bit
              subs      _yerr,_distance
              adds      _y,_incy
              mov       _dummylong,#1 wz
              muxnz     _XY_SetPulseBitMask,_c_Y_Pulse
set_Y_Pulse_Bit_ret ret
'---------------------------------------------------------


'#########################################################
clear_Y_Pulse_Bit               
              mov       _dummylong,#0 wz
              muxnz     _XY_SetPulseBitMask,_c_Y_Pulse
clear_Y_Pulse_Bit_ret ret
'---------------------------------------------------------

              
'#########################################################
ClearXY_Pulse_Bits
              mov       _dummylong,#0 wz
              muxnz     OutA,_XY_ClearPulseBitMask
ClearXY_Pulse_Bits_ret ret
'---------------------------------------------------------


'BEGIN of #########################################################
SetXY_Pulse_Bits
              mov       _dummylong,#1 wz
              muxnz     OutA,_XY_SetPulseBitMask
SetXY_Pulse_Bits_ret ret
'END ---------------------------------------------------------
'# END Subroutines ###################################              



Transfer_Result_To_Hub_RAM                              'ATTENTION ! keep in mind ASM-COG-RAM-vars start with an underline "_"
              nop
              {
              mov       _A2S_Status,#c_A2S_finished       'store value of constant "A2S_finished" in ASM-var "_A2S_Status"
              mov       p,par                           'load HUB-RAM-Adress of SPIN-Variable "S2A_Status" (which is the second parameter in the cognew-command) 
              add       p,#ptr2_A2S_Status              'add offset of variable "A2S_Status"  
              wrlong    _A2S_Status,p                   'write content of ASM-Var "_A2S_Status" to HUB-RAM-Adress of SPIN-var "A2S_Status" 
              }


'CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
'START ASM-CON Assembler-constants
'all ASM-constants start with "_c_"
_delay        long 25_000
_c_signBit    long      |< 31

_c_X_Dir      long      |< X_Dir
_c_X_Pulse    long      |< X_Pulse

_c_Y_Dir      long      |< Y_Dir
_c_Y_Pulse    long      |< Y_Pulse

_c_delay1000  long      1000
_c_delay50MicroSecs long _50microSecs
_c_StartStopSpeed_halfTime long StartStopSpeed_halfTime

_c_Bit16      long      |< 16
_c_Bit18      long      |< 18
_c_Bit20      long      |< 20
_c_Bit22      long      |< 22
'END ASM-CON Assembler-constants #######################



'VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV              
'START ASM-VAR Assembler-variables
'almost all ASM_Variables start with an underline "_"

p             res       1       'Hub-RAM-Adress of second parameter of cognew

_S2A_Status   res       1
_A2S_Status   res       1 

_xStart       res       1
_yStart       res       1

_xEnde        res       1
_yEnde        res       1

_dx           res       1
_dy           res       1

_TestVar1     res       1  
_TestVar2     res       1

_incx         res       1
_incy         res       1
_distance     res       1

_x            res       1
_y            res       1
_xerr         res       1
_yerr         res       1

_actXDirBitVal res      1
_actYDirBitVal res      1

_dummylong    res       1

_Time         res       1
_CntTargetValue  res    1

_StepCounter  res       1

_XYBitMask    res       1

_XY_SetPulseBitMask   res 1
_XY_ClearPulseBitMask res 1